--A lot of this was ported from Hostmod and repurposed - thanks Tyron

freeslot(
	"sfx_hqcd",
	"sfx_rvbonk",
	"sfx_rvsqsh",
	"sfx_rvhit",
	"sfx_rvchln"
)

rawset(_G, "KartVR", "V1")

rawset(_G, "buildTimeString", function(x)
	if x == nil or x == 99999999 then return "N/A" end
	return (""..string.format("%02d", G_TicsToMinutes(x)).."'"..string.format("%02d", G_TicsToSeconds(x)).."\34"..string.format("%02d", G_TicsToCentiseconds(x)))
end)

rawset(_G, "kvr_trim", function(fug)
	return fug:gsub("^%s*(.-)%s*$", "%1")
end)

rawset(_G, "kvr_escape", {
	{a = "\\128", b = "\128"},
	{a = "\\129", b = "\129"},
	{a = "\\130", b = "\130"},
	{a = "\\131", b = "\131"},
	{a = "\\132", b = "\132"},
	{a = "\\133", b = "\133"},
	{a = "\\134", b = "\134"},
	{a = "\\135", b = "\135"},
	{a = "\\136", b = "\136"},
	{a = "\\137", b = "\137"},
	{a = "\\138", b = "\138"},
	{a = "\\139", b = "\139"},
	{a = "\\140", b = "\140"},
	{a = "\\141", b = "\141"},
	{a = "\\142", b = "\142"},
	{a = "\\143", b = "\143"},
})

rawset(_G, "kvr_color", {	[SKINCOLOR_WHITE] = "\x80",	[SKINCOLOR_SILVER] = "\x80",	[SKINCOLOR_SLATE] = "\x80",		[SKINCOLOR_ULTRAVIOLET] = "\x81",	[SKINCOLOR_PURPLE] = "\x81",	[SKINCOLOR_FUCHSIA] = "\x81",		[SKINCOLOR_POPCORN] = "\x82",	[SKINCOLOR_QUARRY] = "\x82",	[SKINCOLOR_YELLOW] = "\x82",	[SKINCOLOR_MUSTARD] = "\x82",	[SKINCOLOR_CROCODILE] = "\x82",	[SKINCOLOR_OLIVE] = "\x82",		[SKINCOLOR_LIME] = "\x83",	[SKINCOLOR_HANDHELD] = "\x83",	[SKINCOLOR_MOSS] = "\x83",	[SKINCOLOR_CAMOUFLAGE] = "\x83",	[SKINCOLOR_ROBOHOOD] = "\x83",	[SKINCOLOR_MINT] = "\x83",	[SKINCOLOR_GREEN] = "\x83",	[SKINCOLOR_PINETREE] = "\x83",	[SKINCOLOR_ALGAE] = "\x83",	[SKINCOLOR_PLAGUE] = "\x83",	[SKINCOLOR_EMERALD] = "\x83",	[SKINCOLOR_SWAMP] = "\x83",	[SKINCOLOR_DREAM] = "\x83",		[SKINCOLOR_PERIWINKLE] = "\x84",	[SKINCOLOR_BLUE] = "\x84",	[SKINCOLOR_BLUEBERRY] = "\x84",	[SKINCOLOR_NOVA] = "\x84",		[SKINCOLOR_CINNAMON] = "\x85",	[SKINCOLOR_RUBY] = "\x85",	[SKINCOLOR_RASPBERRY] = "\x85",	[SKINCOLOR_CHERRY] = "\x85",	[SKINCOLOR_RED] = "\x85",	[SKINCOLOR_CRIMSON] = "\x85",	[SKINCOLOR_MAROON] = "\x85",	[SKINCOLOR_FLAME] = "\x85",	[SKINCOLOR_SCARLET] = "\x85",	[SKINCOLOR_KETCHUP] = "\x85",		[SKINCOLOR_GREY] = "\x86",	[SKINCOLOR_NICKEL] = "\x86",	[SKINCOLOR_BLACK] = "\x86",	[SKINCOLOR_SKUNK] = "\x86",	[SKINCOLOR_JET] = "\x86",		[SKINCOLOR_DAWN] = "\x87",	[SKINCOLOR_SUNSET] = "\x87",	[SKINCOLOR_CREAMSICLE] = "\x87",	[SKINCOLOR_ORANGE] = "\x87",	[SKINCOLOR_PUMPKIN] = "\x87",	[SKINCOLOR_ROSEWOOD] = "\x87",	[SKINCOLOR_BURGUNDY] = "\x87",	[SKINCOLOR_TANGERINE] = "\x87",		[SKINCOLOR_CARIBBEAN] = "\x88",	[SKINCOLOR_AZURE] = "\x88",	[SKINCOLOR_AQUA] = "\x88",	[SKINCOLOR_TEAL] = "\x88",	[SKINCOLOR_CYAN] = "\x88",	[SKINCOLOR_JAWZ] = "\x88",	[SKINCOLOR_CERULEAN] = "\x88",	[SKINCOLOR_NAVY] = "\x88",	[SKINCOLOR_SAPPHIRE] = "\x88",		[SKINCOLOR_PASTEL] = "\x89",	[SKINCOLOR_MOONSLAM] = "\x89",	[SKINCOLOR_DUSK] = "\x89",	[SKINCOLOR_TOXIC] = "\x89",	[SKINCOLOR_MAUVE] = "\x89",	[SKINCOLOR_LAVENDER] = "\x89",	[SKINCOLOR_BYZANTIUM] = "\x89",	[SKINCOLOR_POMEGRANATE] = "\x89",		[SKINCOLOR_GOLD] = "\x8A",	[SKINCOLOR_ROYAL] = "\x8A",	[SKINCOLOR_BRONZE] = "\x8A",	[SKINCOLOR_COPPER] = "\x8A",	[SKINCOLOR_THUNDER] = "\x8A",		[SKINCOLOR_ARTICHOKE] = "\x8B",	[SKINCOLOR_VOMIT] = "\x8B",	[SKINCOLOR_GARDEN] = "\x8B",	[SKINCOLOR_TEA] = "\x8B",	[SKINCOLOR_PISTACHIO] = "\x8B",		[SKINCOLOR_PIGEON] = "\x8C",	[SKINCOLOR_PLATINUM] = "\x8C",	[SKINCOLOR_STEEL] = "\x8C",		[SKINCOLOR_FAIRY] = "\x8D",	[SKINCOLOR_SALMON] = "\x8D",	[SKINCOLOR_PINK] = "\x8D",	[SKINCOLOR_ROSE] = "\x8D",	[SKINCOLOR_BRICK] = "\x8D",	[SKINCOLOR_LEMONADE] = "\x8D",	[SKINCOLOR_BUBBLEGUM] = "\x8D",	[SKINCOLOR_LILAC] = "\x8D",		[SKINCOLOR_SEPIA] = "\x8E",	[SKINCOLOR_BEIGE] = "\x8E",	[SKINCOLOR_WALNUT] = "\x8E",	[SKINCOLOR_BROWN] = "\x8E",	[SKINCOLOR_LEATHER] = "\x8E",	[SKINCOLOR_RUST] = "\x8E",	[SKINCOLOR_WRISTWATCH] = "\x8E",		[SKINCOLOR_PEACH] = "\x8F",	[SKINCOLOR_CARAMEL] = "\x8F",	[SKINCOLOR_CREAM] = "\x8F",})

rawset(_G, "kvr_enabled" , CV_RegisterVar({
	name = "kvr_enabled",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))


rawset(_G, "HasPlayerFinished", function(p)
	return (p.exiting > 0 or p.pflags & PF_TIMEOVER)
end)

rawset(_G, "KVR_playercount", function()
	local headcount = 0
	for p in players.iterate
		if (p and p.valid) then
			headcount = $+1
		end
	end
	return headcount
end)

rawset(_G, "KVR_ingame", function()
	local count = 0
	for p in players.iterate
		if (p and p.valid) and not p.spectator then
			count = $+1
		end
	end
	return count
end)

rawset(_G, "KVR_ratingmean", function(size)
	local VRMean = 0
	local TotalScore = 0
	for p in players.iterate
		if (p and p.valid) then
			TotalScore = $ + p.kvrscore
		end
	end
	if (TotalScore == 0) then
		return 0
	else
		VRMean = FixedInt(FixedFloor(FixedDiv(TotalScore*FRACUNIT, size*FRACUNIT)))
		return VRMean
	end
end)

rawset(_G, "finished", function(p)
	if p.spectator or (not p.mo) then
		return true
	elseif p.pflags & PF_TIMEOVER then
		return true
	elseif p.exiting then
		return true
	end
	return false
end)

rawset(_G, "allfinished", function()
	for p in players.iterate
		if not finished(p) then
			return false
		end
	end
	return true
end)

rawset(_G, "hellavalid", function(p)
	return p.mo and (not p.spectator)
end)


rawset(_G, "kvrrank_text", {
	[11] = "\128Rookie",
	[10] = "\143Wood",
	[9] = "\135Bronze",
	[8] = "\134Silver",
	[7] = "\138Gold",
	[6] = "\140Platinum",
	[5] = "\128Diamond",
	[4] = "\131Chaos Emerald",
	[3] = "\136Super Emerald",
	[2] = "\139Master Emerald",
	[1] = "\129Phantom Ruby"
})


addHook("ThinkFrame", function()
	if leveltime < 1 return end

	for p in players.iterate
		if not (p.mo and p.mo.valid) then continue end
		if (racecountdown < 12*TICRATE)  
		and (racecountdown % TICRATE == (TICRATE-1))
		and not (p.exiting or p.spectator)
		and not p.hurry then
			S_StartSound(p.mo, sfx_hqcd, p) --It's the Drowning theme, RUN
			p.hurry = true
		end
		if p.exiting or (p.pflags & PF_TIMEOVER) then
			if S_SoundPlaying(p.mo, sfx_hqcd) then 
				S_StopSoundByID(p.mo, sfx_hqcd)
			end
			p.hurry = false
		end
	end
end)