--Sourced from Hostmod; preserving all local tables and entities since relevant
--ThinkFrame functions are untouched. I'm just neurotic about properly displaying
--Expert Speed.

local wrapped = {}

-- I KNOW THERE'S A FUCKIN FUNCTION IN SOURCE FOR THIS
-- WHY IS IT NOT EXPOSED TO LUA
-- LAAAAAAAAAAAAAAAAAAAAAAT
local function wrapString(str, width, v, flags, font)
	local words = {}
	for word in str:gmatch("%S+") do table.insert(words, word) end
	local retlines = {}
	local buffer = words[1]
	for i = 2, #words
		local fug = buffer.." "..words[i]
		if v.stringWidth(fug, flags, font) > width then
			table.insert(retlines, buffer)
			buffer = words[i]
		else
			buffer = fug
		end
	end
	table.insert(retlines, buffer)
	return retlines
end

local function doEscapeCode(str)
	for _, v in pairs(kvr_escape)
		str = str:gsub(v.a, v.b)
	end
	return str
end

--This was lifted directly from Hostmod, with a bunch of init stuff gutted.
--I'm rather neurotic about properly displaying Expert Speed on the Scoreboard,
--but everything here helps Hostmod render all the Neo Scoreboard stuff (Tips, 
--Gameplay/Balance Changes, etc) as if it were enabled. You honestly can't tell 
--the difference.


addHook("ThinkFrame", function()
	if leveltime < 1 then return end
	if (HOSTMOD)
		if leveltime == 1 then
			wrapped = {}
		end
		if CV_FindVar("hm_scoreboard").value then
			COM_BufInsertText(server, "hm_scoreboard off")
		end
	end
end)

-- hacked-up TSR scoreboard, WHEEEEEEEEEEEEEEE
-- thanks snu
hud.add(function(v, p, c)
	hud.disable("rankings")
	v.fadeScreen(0xFF00, 16)

	-- store highlight colour here for use in the hud throughout
	local hilicol
	if (CV_FindVar("menuhighlight").value)
		hilicol = CV_FindVar("menuhighlight").value
	elseif (modeattacking)
		hilicol = V_ORANGEMAP
	else
		hilicol = ((gametype == GT_RACE) and V_SKYMAP or V_REDMAP)
	end
	
	if false and consoleplayer and (consoleplayer == server or IsPlayerAdmin(consoleplayer)) then
		local reverseplayers = {}
		for k,v in players.iterate do
		   reverseplayers[v] = k
		end
	end
	
	-- draw lap count and game speed
	if not G_BattleGametype() then
		v.drawString(64, 8, "LAP COUNT", 0, "center")
		v.drawString(64, 16, (numlaps), hilicol, "center")
		v.drawString(256, 8, "GAME SPEED", 0, "center")
		if server.expertspeed then
			v.drawString(256, 16, "EXPERT", hilicol, "center")
		else
			v.drawString(256, 16, CV_FindVar("kartspeed").string, hilicol, "center")
		end
	end
	
	-- draw line between gametypeinfo and teams
	local dupadjust = (v.width()/v.dupx())
	local duptweak = (dupadjust - 320)/2	-- BASEDVIDWIDTH = 320 (based on what?)
	v.drawFill(1-duptweak, 26, dupadjust-2, 1, 0)	-- horizontal
	v.drawFill(160, 26, 1, 162, 0)	-- vertical
	
	v.drawString(4, 188, kvr_trim(mapheaderinfo[gamemap].lvlttl.." "..mapheaderinfo[gamemap].zonttl).." - "..mapheaderinfo[gamemap].subttl, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")

	-- draw right pane
	local fy = 28
	local fx = 163
	local off = 0 -- right pane line offset OH GOD this code is everywhere
	
	if (HOSTMOD)
		local motd = CV_FindVar("hm_motd")
			if motd and motd.value then
				v.drawString(fx, fy, doEscapeCode(CV_FindVar("hm_motd_name").string), V_ALLOWLOWERCASE, "thin")
				v.drawString(fx, fy+10, "\134Contact: "..doEscapeCode(CV_FindVar("hm_motd_contact").string), V_ALLOWLOWERCASE, "small")
				off = $ + 4
			end
	end
		if server.HMNSBmsg then
			for key, val in ipairs(server.HMNSBmsg)
				v.drawString(fx, fy+(off*5), val, V_ALLOWLOWERCASE, "small")
				off = $ + 1
			end
			off = $ + 1
		end
	
		local drew = false
		if (HOSTMOD) then
			for key, val in ipairs(server.HMNSBbalance)
				local drawthatshit = false
				if not val.var then
					drawthatshit = true
				elseif CV_FindVar(val.var) then
					if CV_FindVar(val.var).value then drawthatshit = true end
				end
				if drawthatshit then
					if not drew then
						v.drawString(fx, fy+(5*off), "\134Gameplay / Balance Changes:", V_ALLOWLOWERCASE, "thin")
						off = $ * 2 + 4
					end
					drew = true
					if off % 2 then
						v.drawString(fx+77, fy+(off/2*5), val.disp, V_ALLOWLOWERCASE, "small")
					else
						v.drawString(fx, fy+(off/2*5), val.disp, V_ALLOWLOWERCASE, "small")
					end
					off = $ + 1
				end
			end
		end
		if drew then off = ($ / 2) + ($ % 2) + 1 end
	
		if server.HMNSBtip then
			v.drawString(fx, fy+(off*5), "\134Did You Know?", V_ALLOWLOWERCASE, "thin")
			off = $ + 2
			if #wrapped < 1 then
				hm_dprint("regenerating wrapped tip")
				wrapped = wrapString(server.HMNSBtip, 150, v, V_ALLOWLOWERCASE, "small")
			end
			for _, val in ipairs(wrapped)
				v.drawString(fx, fy+(off*5), val, V_ALLOWLOWERCASE, "small")
				off = $ + 1
			end
			off = $ + 1
		end
	-- draw players
	local tsr_rankings = {}
	for p in players.iterate
		if (p and p.valid) and not p.spectator
			table.insert(tsr_rankings, p)
		end
	end
	table.sort(tsr_rankings, function(a, b) return a.kartstuff[k_position] < b.kartstuff[k_position] end)
	for p in players.iterate
		if p.spectator
			table.insert(tsr_rankings, p)
		end
	end
	if not #tsr_rankings then return end

	for i = 1, #tsr_rankings
		local p = tsr_rankings[i]
		local hy = 28 + (i-1)*10
		local specflag = (p.spectator or p.rs_check2) and V_50TRANS or 0

		-- player ping:
		if (p ~= server)  -- the server doesnt have a ping
		and (netgame)	-- we obviously need to be in a netgame too
			-- my hopes with writing this code is that it's so bad that I'm never allowed to write ping related code ever again
			local ping = p.ping	-- thanks 1.3
			-- get the ping patch we'll use
			local ping_gfxnum, ping_values = 1, {76, 137, 256, 500}
			for i = 1, #ping_values
				if (ping >= ping_values[i]) then ping_gfxnum = i+1 end
			end
			-- sadly p.cmd.latency caps at 11 so it cant go any higher without hacks so huge that I cant be assed
			v.draw(3, hy, v.cachePatch("KVRPING"..ping_gfxnum), specflag)
		end
		-- rank:
		if not p.spectator then
			v.drawString(29, hy+1, p.kartstuff[k_position], 0, "right")
		end
		-- draw skin icon
		if (p.mo and p.mo.valid) then
			local pp = skins[p.mo.skin].facerank
			local cmap = v.getColormap(p.mo.skin, p.mo.color)
			local dieflag = 0
			if p.mo.colorized then cmap = v.getColormap(TC_RAINBOW, p.mo.color) end
			if G_BattleGametype() and p.kartstuff[k_bumper] <= 0 then
				cmap = v.getColormap(TC_RAINBOW, SKINCOLOR_GREY)
				dieflag = V_50TRANS
			end
			v.drawScaled(30<<FRACBITS, (hy+1)<<FRACBITS, FRACUNIT/2, v.cachePatch(pp), specflag|dieflag, cmap)
		end
		-- name: c[p.tsr_team]..p.name
		local c = 0
		local index = p.tsr_team or 6
		local fugname = ""
		if p.HMclan then fugname = $.."\140"..p.HMclan.." \128" end
		--if p.HMclan then fugname = $..hm_color[p.skincolor]..p.HMclan.." | \128" end
		if p == consoleplayer then fugname = $..kvr_color[p.skincolor] end
		if p.name == nil then
			fugname = $.."Glitched player :?"
		else
			fugname = $..p.name
		end
		while v.stringWidth(fugname, V_6WIDTHSPACE|V_ALLOWLOWERCASE|specflag, "thin") > 100
			fugname = $:sub(1, -2)
		end
		if consoleplayer and (consoleplayer == server or IsPlayerAdmin(consoleplayer)) then
			fugname = $.." \x86["..#p.."]"
		end
		v.drawString(39, hy, fugname, V_6WIDTHSPACE|V_ALLOWLOWERCASE|specflag, "thin")
		if (HOSTMOD)
			local restat = CV_FindVar("hm_restat")
			local verbose = CV_FindVar("showallstats")
			if (p.mo and p.mo.valid) then
				if (restat.value and p.HMRs) or verbose.value then
					local restatflag = (verbose.value and p.HMRs) and V_YELLOWMAP or 0
					v.drawString(29, hy, p.kartspeed, restatflag, "small")
					v.drawString(39, hy+6, p.kartweight, restatflag, "small-right")
				end
			end
		end
		-- points:
		local points = ""
		if p.spectator then
			if p.pflags & PF_WANTSTOJOIN then
				points = "WAIT"
			else
				points = "SPEC"
			end
		elseif p.rs_check2 then
			points = "RAGE"
		elseif p.pflags & PF_TIMEOVER then
			points = "NO CONTEST."
		elseif G_BattleGametype() then
			points = p.marescore
		elseif not p.exiting then
			points = "LAP "..(p.laps+1)
		else
			points = buildTimeString(p.realtime)
		end
		v.drawString(157, hy, points, (p.exiting and hilicol or 0)|V_6WIDTHSPACE|specflag, "thin-right")
	end
end, "scores")