--Different table for different classes of Rival music
--Sourced from Hornmod

rawset(_G, "kvr_rivaltable", {})
rawset(_G, "kvr_archrivaltable", {})
rawset(_G, "kvr_solotable", {})
addHook("NetVars", function(net)
	kvr_rivaltable = net($)
	kvr_archrivaltable = net($)
	kvr_solotable = net($)
end)

--Sourced from Hornmod
rawset(_G, "KVR_AddRivalMusic", function(...)
	local packedargs = {...}
	for k, v in ipairs(packedargs) do
		if v.pair and (v.pair[1] ~= nil and v.pair[2] ~= nil) then
			table.insert(kvr_archrivaltable, v)
			print("Rival Music: Added "..v.info.." for "..v.pair[1].." and "..v.pair[2])
		elseif v.pair and (v.pair[1] ~= nil and v.pair[2] == nil)
			table.insert(kvr_solotable, v)
			print("Rival Music: Added "..v.info.." for "..v.pair[1].."(Solo)")
		else
			table.insert(kvr_rivaltable, v)
			print("Rival Music: Added "..v.info)
		end
	end
end)