assert(juggy, "Juggy_Definitions.lua must be defined first.")
juggy.KVRChat = function (parameters)
	if(parameters.message:lower() == "!record") then
		chatprintf(parameters.player, "*Current record: "..'\n'.."\x84"..parameters.player.kvrwins.." W"..'\n'.."\x85"..parameters.player.kvrlosses.." L"..'\n'.."\x83"..parameters.player.kvrok.." OK")
		parameters.returntype = true
		return parameters
	end
	
	if parameters.message:sub(1, 4):lower() == "!ch " then
		COM_BufInsertText(parameters.player, "kvr_rival \"" .. parameters.message:sub(5) .. "\" in_chat")
		parameters.returntype = true
		return parameters
	end
	
	if parameters.message:sub(1, 4):lower() == "!bt " then -- Place bet in chat
		if parameters.message:sub(5,7):lower() == "all"
			COM_BufInsertText(parameters.player, "kvr_wager \"" .. (parameters.player.kvrscore-1) .. "\" in_chat")
		else
			COM_BufInsertText(parameters.player, "kvr_wager \"" .. parameters.message:sub(5) .. "\" in_chat")
		end
		parameters.returntype = true
		return parameters
	end
	
	if parameters.message:sub(1, 3):lower() == "!by" then -- Agree to Rival's bet
		if parameters.player.kvrpendingrival
			if players[parameters.player.kvrpendingrival-1].kvrwager
				COM_BufInsertText(parameters.player, "kvr_wager \"" .. players[parameters.player.kvrpendingrival-1].kvrwager .. "\" in_chat")
			else
				chatprintf(parameters.player, "*They haven't bet anything yet!")
			end
		else
			chatprintf(parameters.player, "You need to have a rival first!")
		end
		parameters.returntype = true
		return parameters
	end
	
	if parameters.message:sub(1, 4):lower() == "!bn" then -- Decline bet
		COM_BufInsertText(parameters.player, "kvr_wager \"0\" in_chat")
		parameters.returntype = true
		return parameters
	end
	
	if parameters.message:sub(1, 4):lower() == "!br " then -- Raise Rival's bet
		if parameters.player.kvrpendingrival
			if players[parameters.player.kvrpendingrival-1].kvrwager
				COM_BufInsertText(parameters.player, "kvr_wager \"" .. (players[parameters.player.kvrpendingrival-1].kvrwager + (parameters.message:sub(5))).. "\" in_chat")
			else
				chatprintf(parameters.player, "*They haven't bet anything yet!")
			end
		else
			chatprintf(parameters.player, "You need to have a rival first!")
		end
		parameters.returntype = true
		return parameters
	end
	
	if parameters.message:sub(1, 4):lower() == "!bl " then -- Haggle with Rival's bet
		if parameters.player.kvrpendingrival
			if players[parameters.player.kvrpendingrival-1].kvrwager
				COM_BufInsertText(parameters.player, "kvr_wager \"" .. (players[parameters.player.kvrpendingrival-1].kvrwager - (parameters.message:sub(5))).. "\" in_chat")
			else
				chatprintf(parameters.player, "*They haven't bet anything yet!")
			end
		else
			chatprintf(parameters.player, "You need to have a rival first!")
		end
		parameters.returntype = true
		return parameters
	end
	
	if parameters.message:lower() == "!rival"
		if parameters.player.kvrrival ~= "none"
			--print(tostring(p.kvrrival))
			chatprintf(parameters.player, "Current Rival: "..parameters.player.kvrrival..'\n'.."Record: \x83"..parameters.player.kvrrivalwins.."\x80 - \x85"..parameters.player.kvrrivallosses.."\x80 - \x82"..parameters.player.kvrrivaldraws)
		else
			chatprintf(parameters.player, "*Say \x88\"!ch <name/node>\"\x80 to declare a rival!")
		end
		parameters.returntype = true
		return parameters
	end
	if parameters.message:lower() == "!wager"
		chatprintf(parameters.player, "*Say \x88\"!bt \"\x80, followed by a number (at least 50), to place a bet with your Rival. Or say \x88\"!bt all\"\x80 to bet everything you have.")
		chatprintf(parameters.player, "*Say \x88\"!by\"\x80 or \x88\"!bn\"\x80 to accept or decline a bet.")
		chatprintf(parameters.player, "*Say \x88\"!br\"\x80 or \x88\"!bl\"\x80, followed by a number, to raise or lower your Rival's proposed bet by that amount.")
		parameters.returntype = true
		return parameters
	end
	
	return parameters
end

juggy.createChatModule(juggy.KVRChat, juggy.CHATMOD_INTEROP)